HDU 3038 How Many Answers Are Wrong 题解

How Many Answers Are Wrong

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)
Total Submission(s): 10432    Accepted Submission(s): 3785


Problem Description
TT and FF are ... friends. Uh... very very good friends -________-b

FF is a bad boy, he is always wooing TT to play the following game with him. This is a very humdrum game. To begin with, TT should write down a sequence of integers-_-!!(bored).

Then, FF can choose a continuous subsequence from it(for example the subsequence from the third to the fifth integer inclusively). After that, FF will ask TT what the sum of the subsequence he chose is. The next, TT will answer FF's question. Then, FF can redo this process. In the end, FF must work out the entire sequence of integers.

Boring~~Boring~~a very very boring game!!! TT doesn't want to play with FF at all. To punish FF, she often tells FF the wrong answers on purpose.

The bad boy is not a fool man. FF detects some answers are incompatible. Of course, these contradictions make it difficult to calculate the sequence.

However, TT is a nice and lovely girl. She doesn't have the heart to be hard on FF. To save time, she guarantees that the answers are all right if there is no logical mistakes indeed.

What's more, if FF finds an answer to be wrong, he will ignore it when judging next answers.

But there will be so many questions that poor FF can't make sure whether the current answer is right or wrong in a moment. So he decides to write a program to help him with this matter. The program will receive a series of questions from FF together with the answers FF has received from TT. The aim of this program is to find how many answers are wrong. Only by ignoring the wrong answers can FF work out the entire sequence of integers. Poor FF has no time to do this job. And now he is asking for your help~(Why asking trouble for himself~~Bad boy)
 
Input
Line 1: Two integers, N and M (1 <= N <= 200000, 1 <= M <= 40000). Means TT wrote N integers and FF asked her M questions.

Line 2..M+1: Line i+1 contains three integer: Ai, Bi and Si. Means TT answered FF that the sum from Ai to Bi is Si. It's guaranteed that 0 < Ai <= Bi <= N.

You can assume that any sum of subsequence is fit in 32-bit integer.
 
Output
A single line with a integer denotes how many answers are wrong.
 
Sample Input
10 5 1 10 100 7 10 28 1 3 32 4 6 41 6 6 1
 
Sample Output
1
 
Source
 
题意:每次给出某段区间和,如果可能合法就认为他是事实,否则算作谎话使答案加一并忽略它。求总共多少谎话。
思路:不妨将区间左闭右开表示,一句话有逻辑错误当且仅当左右端点在之前都出现过,因此想到并查集。可以用并查集记录当前节点到父亲节点的差值,其中根节点差值为0,在路径压缩时便可求出当前节点到根节点的偏移量。在合并时如果两端点在一个集合当中,就判断到根节点的偏移量的和是否等于题里给的当前区间和;如果不在一个集合就合并了,合并时可以正常启发式合并,在合并时要更改一下被移动的那个根节点存的偏移量,即变为相对另一个根节点的偏移量。另外,本题多组数据,题里没说。
代码:
#include <iostream>
#include <fstream>
#include <sstream>
#include <cstdlib>
#include <cstdio>
#include <cmath>
#include <string>
#include <cstring>
#include <algorithm>
#include <queue>
#include <stack>
#include <vector>
#include <set>
#include <map>

using namespace std;

#define pau system("pause")
#define ll long long
#define pii pair<int, int>
#define pb push_back
#define mp make_pair

const double pi = acos(-1.0);

int n, m;
int parent[200015], Rank[200015];
ll val[200015];
void ini() {
    for (int i = 1; i <= n + 1; ++i) {
        parent[i] = i;
        Rank[i] = 1;
        val[i] = 0;
    }
}
int Find(int x) {
    //cout << x << endl; pau;
    if (x == parent[x]) return x;
    int root = Find(parent[x]);
    val[x] += val[parent[x]];
    parent[x] = root;
    return root;
}
bool uni(int x, int y, ll z) {
    int _x = Find(x);
    int _y = Find(y);
    if (_x == _y) {
        if (val[y] - val[x] == z) return true;
        else return false;
    } else {
        if (Rank[_x] < Rank[_y]) {
            val[_x] = -z + val[y] - val[x];
            parent[_x] = _y;
        } else {
            val[_y] = -val[y] + val[x] + z;
            parent[_y] = _x;
            if (Rank[_x] == Rank[_y]) ++Rank[_x];
        }
        return true;
    }
}
int main() {
    while (~scanf("%d%d", &n, &m)) {
        ini();
        int ans = 0;
        for (int i = 1; i <= m; ++i) {
            int x, y; ll z;
            scanf("%d%d%lld", &x, &y, &z);
            ans += !uni(x, y + 1, z);
            /*for (int i = 1; i <= n + 1; ++i) {
                cout << val[i] << ' ';
            }
            cout << endl;*/
        }
        printf("%d
", ans);
    }
    return 0;
}
/*
3 3
1 2 3
2 3 4
1 3 7
3 4
1 2 3
2 3 4
1 3 7
2 2 0
*/
原文地址:https://www.cnblogs.com/BIGTOM/p/7875944.html